<?php
// This is for Poedit.
function mariginari_ecne_poo() {
	$mariginari_plugin_name=__('enhanced comment notification email', 'mariginari');
	$mariginari_plugin_description=__('Links to comment permalink from the notification email.', 'mariginari');
}

/*
*	Text Domain: mariginari
*    	Plugin URI: http://mummila.net/nuudelisoppa/mariginari-theme-for-wordpress/
* 	Author: Jani Uusitalo
* 	Author URI: http://mummila.net/
*	Plugin Name: enhanced comment notification email
*   	Description: Links to comment permalink from the notification email.
* 	Version: 9000
*
* 
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program; if not, write to the Free Software
*	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/



// %i = comment id. %n would be the comment number (on current page)
// and %% a plain %, but I haven't actually implemented those yet.
define('MARIGINARI_COMMENT_PERMALINK_FORMAT', 'comment-%i');
define('MARIGINARI_TRACKBACK_PERMALINK_FORMAT', 'comment-%i');
define('MARIGINARI_PINGBACK_PERMALINK_FORMAT', 'comment-%i');

function mariginari_format_comment_permalink($comment, $permalink_format) {

	$comment_id = $comment->comment_ID;
	$comment_anchor = preg_replace('/(?<!%)%i/', $comment_id, $permalink_format);

	// This is just a sketch.
	//$comment_number = 0;	# This definitely lacks substance.
	//$comment_anchor = preg_replace('/[^%]%n/', $comment_id, $permalink_format);

	return get_permalink($comment->comment_post_ID) . '#' . $comment_anchor;
}
function mariginari_get_comment_permalink($comment) {
	return mariginari_format_comment_permalink($comment, MARIGINARI_COMMENT_PERMALINK_FORMAT);
}
function mariginari_get_trackback_permalink($comment) {
	return mariginari_format_comment_permalink($comment, MARIGINARI_TRACKBACK_PERMALINK_FORMAT);
}
function mariginari_get_pingback_permalink($comment) {
	return mariginari_format_comment_permalink($comment, MARIGINARI_PINGBACK_PERMALINK_FORMAT);
}

// This takes the comment as a parameter instead of referring to a global like the original at:
// http://core.svn.wordpress.org/tags/2.9.1/wp-includes/comment-template.php#630
function mariginari_get_comment_type($comment) {
	if ( '' == $comment->comment_type )
		$comment->comment_type = 'comment';

	return apply_filters('get_comment_type', $comment->comment_type);
}

// This relies on and extends:
// http://core.svn.wordpress.org/tags/2.9.1/wp-includes/pluggable.php#986
function mariginari_enhance_comment_email($message_body, $comment_id) {

	$comment = get_comment($comment_id);
	$comment_type = mariginari_get_comment_type($comment);

	// Note that the text domain for these is the core and not 'mariginari',
	// so that they're localized just as the originals in the core.
	$all_comments_pseudohook = __('You can see all comments on this post here: ');
	$comment_source_pseudohook = sprintf( __('Author : %1$s (IP: %2$s , %3$s)'), $comment->comment_author, $comment->comment_author_IP, $comment_author_domain ) . "\r\n";
	$comment_permalink_intro = __('This comment can be read and linked to at: ', 'mariginari');

	$all_trackbacks_pseudohook = __('You can see all trackbacks on this post here: ');
	$trackback_source_pseudohook = sprintf( __('Website: %1$s (IP: %2$s , %3$s)'), $comment->comment_author, $comment->comment_author_IP, $comment_author_domain ) . "\r\n";
	$trackback_permalink_intro = __('This trackback can be read and linked to at: ', 'mariginari');

	$all_pingbacks_pseudohook = __('You can see all pingbacks on this post here: ');
	$pingback_source_pseudohook = sprintf( __('Website: %1$s (IP: %2$s , %3$s)'), $comment->comment_author, $comment->comment_author_IP, $comment_author_domain ) . "\r\n";
	$pingback_permalink_intro = __('This pingback can be read and linked to at: ', 'mariginari');


	$timestamp = sprintf(__('%1$s at %2$s', 'mariginari'), get_comment_date(), get_comment_time());

	if ('comment' == $comment_type) {
		$message_body = str_replace($comment_source_pseudohook, 
				$timestamp. "\r\n"
				.$comment_source_pseudohook, $message_body);
		$message_body = str_replace($all_comments_pseudohook, 
				$comment_permalink_intro. "\r\n"
				.mariginari_get_comment_permalink($comment) ."\r\n\r\n"
				.$all_comments_pseudohook, $message_body);
	} elseif ('trackback' == $comment_type) {
		$message_body = str_replace($trackback_source_pseudohook, 
				$timestamp. "\r\n"
				.$trackback_source_pseudohook, $message_body);
		$message_body = str_replace($all_trackbacks_pseudohook, 
				$trackback_permalink_intro. "\r\n"
				.mariginari_get_trackback_permalink($comment) ."\r\n\r\n"
				.$all_trackbacks_pseudohook, $message_body);
	} elseif ('pingback' == $comment_type) {
		$message_body = str_replace($pingback_source_pseudohook, 
				$timestamp. "\r\n"
				.$pingback_source_pseudohook, $message_body);
		$message_body = str_replace($all_pingbacks_pseudohook, 
				$pingback_permalink_intro. "\r\n"
				.mariginari_get_pingback_permalink($comment) ."\r\n\r\n"
				.$all_pingbacks_pseudohook, $message_body);
	}

	return $message_body;
}
add_filter('comment_notification_text', 'mariginari_enhance_comment_email', 10, 2);

?>
