<?php
// This is for Poedit.
function mariginari_footnotes_poo() {
	$mariginari_plugin_name=__('footnotes', 'mariginari');
	$mariginari_plugin_description=__('Provides shortcode for inserting footnotes.', 'mariginari');
}

/*
*	Text Domain: mariginari
*    	Plugin URI: http://mummila.net/nuudelisoppa/mariginari-theme-for-wordpress/
* 	Author: Jani Uusitalo
* 	Author URI: http://mummila.net/
*	Plugin Name: footnotes
*   	Description: Provides shortcode for inserting footnotes.
* 	Version: 9000
*
* 
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program; if not, write to the Free Software
*	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

// Generate style sheet.
if ($_GET['mariginaristyle'] == 'footnotes') {
	header("Content-type: text/css");
	include("../../../wp-load.php");
	return mariginari_get_footnotes_style();
}

// Hook up generated style sheet.
if (function_exists('add_action')) {
	add_action('wp_print_styles', 'mariginari_footnotes_style');
}
function mariginari_footnotes_style() {
	wp_enqueue_style('mariginari-footnotes-style', WP_PLUGIN_URL.'/'.plugin_basename(__FILE__).'?mariginaristyle=footnotes',array(), '9000', 'all');
}

// The actual shortcodes' translation.
if (function_exists('add_filter')) {
	add_filter('the_content', 'mariginari_footnotes', 8);
}
function mariginari_translate_footnote($attrs = null, $content = null) {
	global $post;
	global $mariginari_footnotes;

	$post_permalink = get_permalink();
	$options = mariginari_load_footnotes_options();

	$i = count($mariginari_footnotes);
	$mariginari_footnotes[$i]->text = do_shortcode($content);
	$mariginari_footnotes[$i]->number = $i+1;
	$mariginari_footnotes[$i]->short = mariginari_shorten_footnote( strip_tags($mariginari_footnotes[$i]->text) );
	return '<a id="'.$post->post_name.'-reference-'.$mariginari_footnotes[$i]->number.'" href="'.$post_permalink.'#'.$post->post_name.'-footnote-' . $mariginari_footnotes[$i]->number . '" class="mariginari-footnote-reference" title="'.sprintf($options['footnote reference title'], $mariginari_footnotes[$i]->number, $mariginari_footnotes[$i]->short).'">'.$mariginari_footnotes[$i]->number.'</a>';
}
function mariginari_rip_changelog($attrs = null, $content = false) {
	global $mariginari_changelog;
	$mariginari_changelog = $content;
	return '';
}
function mariginari_footnotes($content = null)
{
	global $post;

	$options = mariginari_load_footnotes_options();

	global $shortcode_tags;
	$old_shortcodes = $shortcode_tags;
	$shortcode_tags = array();

	global $mariginari_footnotes;
	$mariginari_footnotes = array();
	add_shortcode(__('footnote', 'mariginari'), 'mariginari_translate_footnote');
	$content = do_shortcode($content);

	// Rip out changelog.
	global $mariginari_changelog;
	$mariginari_changelog = false;
	$shortcode_tags = array();
	add_shortcode(__('changelog', 'mariginari'), 'mariginari_rip_changelog');

	$content = do_shortcode($content);

	if ( count($mariginari_footnotes) > 0 ) {
		$content .= '
	<p class="mariginari-footnotes"><a class="mariginari-footnotes" id="mariginari-footnotes-'.$post->ID.'" href="'.get_permalink($post->ID).'#mariginari-footnotes-'.$post->ID.'" title="'.sprintf( $options['footnotes permalink title'], mariginari_get_the_title_attribute() ).'">'.sprintf( $options['footnotes permalink text'], mariginari_get_the_title_attribute() ).'</a></p>';

		$content .= '<ol class="mariginari-footnotes">';
		foreach($mariginari_footnotes as $note) {
			$content .= '<li><a id="'.$post->post_name.'-footnote-'.$note->number.'" href="'.$post_permalink.'#'.$post->post_name.'-footnote-'.$note->number.'" class="mariginari-footnote" title="'.$options['footnote permalink title'].'">'.$note->number.'</a> '.$note->text.' <a title="'.$options['back to paragraph link title'].'" href="'.$post_permalink.'#'.$post->post_name.'-reference-'.$note->number.'" class="mariginari-footnote-return">&para;</a></li>';
		}
		$content .= "</ol>";
	}

	if ( !empty($mariginari_changelog) ) {
		$content .= '['.__('changelog', 'mariginari').']'.$mariginari_changelog.'[/'.__('changelog', 'mariginari').']';
	}

	$shortcode_tags = $old_shortcodes;
	return $content;
}

// http://vision-media.ca/resources/php/php-word-limit
function mariginari_shorten_footnote($note) {
	$words = explode(' ', $note);
	return implode(  ' ', array_slice( $words, 0, mariginari_get_footnotes_option('words in footnote excerpt') )  ) . '&hellip;';
}

// Settings are centralized here to ease changes.
function mariginari_load_footnotes_options() {
	$options['footnotes permalink text'] = __('Footnotes', 'mariginari');
	$options['footnotes permalink title'] = __('Footnotes for %s', 'mariginari');
	$options['footnote reference title'] = __('Footnote #%d: %s', 'mariginari');
	$options['footnote permalink title'] = __('Permanent link to this footnote', 'mariginari');
	$options['back to paragraph link title'] = __('Return to referring paragraph', 'mariginari');
	$options['words in footnote excerpt'] = 8;
	return $options;
}

// Get individual options.
function mariginari_get_footnotes_option($option_name) {
	$options = mariginari_load_footnotes_options();
	return $options[$option_name];
}


// WP's the_title_attribute() is crap.
if (!function_exists('mariginari_get_the_title_attribute')) {
function mariginari_get_the_title_attribute() {
	$title = get_the_title();

	if ( strlen($title) == 0 )
		return;

	return esc_attr(strip_tags($title));
}
}

// Generate the style sheet.
function mariginari_get_footnotes_style() {
?>
p.mariginari-footnotes {
	margin-top:3em;
	text-indent:0;
	font-size: .8em
}

ol.mariginari-footnotes {
	margin: 0;
	margin-bottom: 3em;
	padding: 0;
	font-size: .8em;
	list-style: none;
}
ol.mariginari-footnotes li {
	list-style: none !important;
}

a.mariginari-footnote-reference,
a.mariginari-footnote-reference:link,
a.mariginari-footnote-reference:active,
a.mariginari-footnote-reference:visited,
a.mariginari-footnote,
a.mariginari-footnote:link,
a.mariginari-footnote:active,
a.mariginari-footnote:visited {
	font-size: .8em;
	font-variant:small-caps;
	vertical-align:super;
	text-decoration:none;
}
a.mariginari-footnote-reference:before,
a.mariginari-footnote:before {
	content:'['
}
a.mariginari-footnote-reference:after,
a.mariginari-footnote:after {
	content:']'
}

ol.mariginari-footnotes a.mariginari-footnote {
	font-size: 1em;
	vertical-align:baseline
}
<?php
}

?>
