<?php
// This is for Poedit.
function mariginari_pc_poo() {
	$mariginari_plugin_name=__('parental control', 'mariginari');
	$mariginari_plugin_description=__('Filters profanity from posts and comments, hides adult-rated posts unless user explicitly chooses to view them.', 'mariginari');
}

/*
*	Text Domain: mariginari
*    	Plugin URI: http://mummila.net/nuudelisoppa/mariginari-theme-for-wordpress/
* 	Author: Jani Uusitalo
* 	Author URI: http://mummila.net/
*	Plugin Name: parental control
*   	Description: Filters profanity from posts and comments, hides adult-rated posts unless user explicitly chooses to view them.
* 	Version: 9000
*
* 
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program; if not, write to the Free Software
*	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/



define('MARIGINARI_CENSORED_CHARACTER', '*');

// pc plays the second fiddle to ftc.
if ( !defined('MARIGINARI_RULES_COOKIE') ) {
	define('MARIGINARI_RULES_COOKIE', 'mariginari_respects_the_rules');
}
if ( !defined('MARIGINARI_RESPECTS_THE_RULES') ) {
	// "Because setting a cookie with a value of FALSE will try to delete the cookie,
	// you should not use boolean values. Instead, use 0 for FALSE  and 1 for TRUE."
	// (http://fi2.php.net/setcookie)
	define('MARIGINARI_RESPECTS_THE_RULES', 1);
}
define('MARIGINARI_IS_NOT_PC', MARIGINARI_RESPECTS_THE_RULES);

define('MARIGINARI_PC_TOGGLER_URL_PARAMETER', 'parentalcontrol');
if ( function_exists('mariginari_fucks_with_words') ) {
	if ( !mariginari_fucks_with_words() || is_feed() ) {
	}
}

// Provide means to disable filtering.
// The toggler was adapted from Smart Unread Comments.
if (isset($_GET[MARIGINARI_PC_TOGGLER_URL_PARAMETER])) {
	mariginari_toggle_filtering();

	// Try to return to referring page.
	if ( isset($_SERVER['HTTP_REFERER']) && $_SERVER['HTTP_REFERER'] != '' ) {
		$location = $_SERVER['HTTP_REFERER'];
	}
	// It ought to be the current page, sans the toggler parameter.
	else {
		$location = 'http'.( empty($_SERVER['HTTPS']) ? '' : 's' ).'://'.$_SERVER["HTTP_HOST"].( str_replace('?'.$_SERVER['QUERY_STRING'], '', $_SERVER['REQUEST_URI']) );
	}
	header ('Location: ' . $location);
}
function mariginari_toggle_filtering() {
	if (mariginari_is_pc()) {
		$new_state = MARIGINARI_IS_NOT_PC;
		$cookie_age = 3600*24*365;	// 365 days
		$time_now = strtotime(gmdate('Y-m-d H:i:s')) + get_settings('gmt_offset') * 3600;
		$cookie_expires = $time_now + $cookie_age;

	}
	else {
		$new_state = '';
		$cookie_expires = 1;	// 1 s. past epoch
	}

	$cookie_path = parse_url(get_bloginfo('siteurl'));
	if ($cookie_path['path'] == "") {
		$cookie_path['path'] = "/";
	}

	setcookie(MARIGINARI_RULES_COOKIE, $new_state, $cookie_expires, $cookie_path['path']);
}

// Returns the current state: is content filtered or not?
function mariginari_is_pc() {
	$because_of_the_cookie = true;
	if ( isset($_COOKIE[MARIGINARI_RULES_COOKIE]) && $_COOKIE[MARIGINARI_RULES_COOKIE] == MARIGINARI_IS_NOT_PC) {
		$because_of_the_cookie = false;
	}

	return $because_of_the_cookie;
}


function mariginari_get_pc_switch() {
	$toggler = '?'.MARIGINARI_FTR_TOGGLER_URL_PARAMETER;
	if (mariginari_is_pc()) {
		return '<a id="mariginari-pc-switch-lever" href="'.$toggler.'" title="'.__('Stop filtering adult content!', 'mariginari').'">'.__('Stop filtering adult content!', 'mariginari').'</a>';
	}
	else {
		return '<a id="mariginari-pc-switch-lever" href="'.$toggler.'" title="'.__('Filter adult content!', 'mariginari').'">'.__('Filter adult content!', 'mariginari').'</a>';
	}
}

// Profanities filter.
add_filter('the_title', 'mariginari_pc_filter');
add_filter('single_post_title', 'mariginari_pc_filter');
add_filter('the_excerpt','mariginari_pc_filter');
add_filter('the_content', 'mariginari_pc_filter');
add_filter('comment_author','mariginari_pc_filter');
add_filter('comment_text', 'mariginari_pc_filter');

function mariginari_pc_replace($search, $replace, $text) {
	$opening_tag_in_text = explode('<', $text);
	$i = 0;
	foreach ($opening_tag_in_text as $tag) {
		$tag_contents = explode('>', $tag);
		$tag_contents[count($tag_contents)-1] = preg_replace($search, $replace, $tag_contents[count($tag_contents)-1]);
		$opening_tag_in_text[$i] = implode('>', $tag_contents);
		$i++;
	}
	$text = implode('<', $opening_tag_in_text);
	return $text;
}

function mariginari_pc_filter($content) {

	// Don't filter if disabled, don't filter feeds or admin area.
	if ( !mariginari_is_pc() || is_feed() || is_admin() ) {
		return $content;
	}

	// Test this separately to skip the query in case one of the conditions above is true.
	$profanities = mariginari_get_profanities();
	if ( empty($profanities) ) {
		return $content;
	}

	// Look for each listed nasty word in turn.
	foreach ($profanities as $nasty_word) {

		// Skip insane values right up to make it easier rest of the way.
		if (strlen($nasty_word) < 3) {
			continue;
		}

		$nasty_initial = substr($nasty_word, 0, 1);
		$nasty_is_wild = ( substr($nasty_word, -1) == '*' ? true : false );
		if ($nasty_is_wild) {
			$nasty_rest = substr( $nasty_word, 1, strlen($nasty_word)-2 );
		}
		else {
			$nasty_rest = substr($nasty_word, 1);
		}

		$nasty_search = '/\b('.$nasty_initial.')'.$nasty_rest.($nasty_is_wild ? '' : '\b').'/i';
		$nasty_rest_replacement = '';
		while ( strlen($nasty_rest_replacement) < strlen($nasty_rest) ) {
			$nasty_rest_replacement .= MARIGINARI_CENSORED_CHARACTER;
		}
		$nasty_replacement = '$1'.$nasty_rest_replacement;

		$content = mariginari_pc_replace($nasty_search, $nasty_replacement, $content);
	}

	return $content;
}

// Read list of profanities from a tagged post.
function mariginari_get_profanities() {
	global $post;
	$current_post = $post;

	$profanities_from_posts = array();
	$that_contain_profanities_lists = array(
		'post_type' => 'any',
		'numberposts' => -1,
		'post_status' => 'any',
		'tag' => __('mariginari-profanities', 'mariginari')
	);

	$profanities_posts = get_posts($that_contain_profanities_lists);

	if ($profanities_posts === false) {
		return array();
	}

	$profanities_from_posts = array();
		$newline = '
';
	foreach ($profanities_posts as $post) {
		setup_postdata($post);
		$profanities_from_post = explode($newline, get_the_content());
		foreach ($profanities_from_post as $profanity) {
			$profanity = trim(strip_tags($profanity));
			if ( !empty($profanity) ) {
				$profanities_from_posts[] = $profanity;
			}
		}
	}
	if ( empty($profanities_from_posts) ) {
		return array();
	}

	$post = $current_post;
	setup_postdata($post);
	return array_unique($profanities_from_posts);
}



// Adult-rated posts filter.
add_filter('posts_where', 'mariginari_pc_posts_where');
add_filter('get_previous_post_where', 'mariginari_pc_posts_where');
add_filter('get_next_post_where', 'mariginari_pc_posts_where');

function mariginari_get_tag_id_by_slug($slug) {
	global $wpdb;
	$tag_id = $wpdb->get_var( $wpdb->prepare("SELECT term_id FROM $wpdb->terms WHERE slug = '%s';", $slug)  );
	return $tag_id;
}
function mariginari_get_tag_taxonomy_id_by_slug($slug) {
	global $wpdb;

	$tax_id = $wpdb->get_var(  $wpdb->prepare( "SELECT term_taxonomy_id FROM $wpdb->term_taxonomy WHERE term_id = '".mariginari_get_tag_id_by_slug($slug)."' AND taxonomy = 'post_tag';" )  );

	return $tax_id;
}

function mariginari_pc_posts_where($where) {
	global $wpdb;

	// Don't filter if disabled, don't filter feeds or admin area, don't filter from logged-in users.
	if ( !mariginari_is_pc() || is_feed() || is_admin() || is_user_logged_in() ) {
		return $where;
	}
	$tax_id = mariginari_get_tag_taxonomy_id_by_slug(__('mariginari-adult-rated', 'mariginari'));
	if ($tax_id === null) {
		return $where;
	}
	$rated_posts = $wpdb->get_var(  $wpdb->prepare( "SELECT COUNT(*) FROM $wpdb->term_relationships WHERE term_taxonomy_id = '".$tax_id."';" )  );
	if ($rated_posts > 0) {
		$where .= " AND ( ID <> (SELECT object_id FROM $wpdb->term_relationships WHERE term_taxonomy_id = '".$tax_id."') )";
	}

	return $where;
}

?>
