<?php
// This is for Poedit.
function mariginari_pranch_poo() {
	$mariginari_plugin_name=__('pranch', 'mariginari');
	$mariginari_plugin_description=__('Gives each paragraph an individual anchor and a permalink.', 'mariginari');
}

/*
*	Text Domain: mariginari
*    	Plugin URI: http://mummila.net/nuudelisoppa/mariginari-theme-for-wordpress/
* 	Author: Jani Uusitalo
* 	Author URI: http://mummila.net/
*	Plugin Name: pranch
*   	Description: Gives each paragraph an individual anchor and a permalink.
* 	Version: 9001
*
* 
*	This program is free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*	
*	This program is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*	GNU General Public License for more details.
*
*	You should have received a copy of the GNU General Public License
*	along with this program; if not, write to the Free Software
*	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/



// Generate style sheet.
if ($_GET['mariginaristyle'] == 'pranch') {
	header("Content-type: text/css");
	include("../../../wp-load.php");
	return mariginari_get_pranch_style();
}

// Hook up generated style sheet.
if (function_exists('add_action')) {
	add_action('wp_print_styles', 'mariginari_pranch_style');
}
function mariginari_pranch_style() {
	wp_enqueue_style('mariginari-pranch-style', WP_PLUGIN_URL.'/'.plugin_basename(__FILE__).'?mariginaristyle=pranch',array(), '9000', 'all');
}

function mariginari_inject_p_id($id, $content) {
	$pattern = '@\<p([^>]*)>(.*)@';
	if ( preg_match($pattern, $content, $atts) > 0 ) {
		$content = '<p id="'.$id.'"'.( empty($atts[1]) ? '' : ' ' ).$atts[1].'>'.$atts[2];
	}
	return $content;
}
function mariginari_pranch_pick_opening_p($content) {
	$pattern = '@\<p([^>]*)>.*@';
	if ( preg_match($pattern, $content, $atts) > 0 ) {
		$attributes = array(
			'id'=>null,
			'class'=>null
		);
		$attribute_assignment = strtok($atts[0], ' ');
		while ($attribute_assignment !== false) {
			$attribute = explode('=', $attribute_assignment);
			if ( count($attribute) > 1 ) {
				$attributes[$attribute[0]] = str_replace('"', '', str_replace("'", '', $attribute[1]));
			}
			$attribute_assignment = strtok(' ');
		}
		return $attributes;
	}
	else {
		return array(
			'id'=>null,
			'class'=>null
		);
	}
}
function mariginari_is_a_p($p) {
	$p = trim($p);
	if ( empty($p) ) {
		return false;
	}
	$first_p = strpos($p, '<p');
	if ( $first_p === false ) {
		return false;
	}
	$first_pre = strpos($p, '<pre');
	$opening_tag = strpos($p, '<');
	if ( $opening_tag == $first_p && ($first_pre === false || $first_pre != $first_p) ) {
		return true;
	}
	else {
		return false;
	}
}
function mariginari_pranch($content, $context_id) {

	global $post;
	$post_permalink = get_permalink();

	$excluded_classes = array();
	$excluded_classes[] = 'mariginari-post-changelog';
	$excluded_classes[] = 'mariginari-footnotes';

	if ( !empty($context_id) && !empty($post_permalink) ) {
		$content_between_bqs = explode('<blockquote', $content);
		if ( count($content_between_bqs) < 2 ) {
			$content = implode($content_between_bqs);
		}
		else {
			foreach (array_keys($content_between_bqs) as $content_block) {
				$content_in_blockquote = explode('</blockquote>', $content_between_bqs[$content_block]);
				if ( count($content_in_blockquote) > 1 ) {
					$content_between_bqs[$content_block] = $content_in_blockquote[0].'</blockquote>'
						.mariginari_pranch($content_in_blockquote[1], $context_id);
				}
				else {
					$content_between_bqs[$content_block] = mariginari_pranch($content_in_blockquote[0], $context_id);
				}
			}
			return implode('<blockquote', $content_between_bqs);
		}
		$content_paragraph = explode('</p>', $content);
		if ( count($content_paragraph) < 2 ) {
			$content = implode($content_paragraph);
		}
		else {
			foreach (array_keys($content_paragraph) as $suchandsuch) {
				$p = $content_paragraph[$suchandsuch];
				if ( mariginari_is_a_p($p) ) {
					$opening_tag = mariginari_pranch_pick_opening_p($content_paragraph[$suchandsuch]);
					$isnt_excluded = true;
					$p_classes = explode(' ', $opening_tag['class']);
					foreach ($p_classes as $class) {
						if ( in_array($class, $excluded_classes) ) {
							$isnt_excluded = false;
							break;
						}
					}
					if ( $isnt_excluded ) {
						if ($opening_tag['id'] != null) {
							$id = $opening_tag['id'];
						}
						else {
							$id = $context_id.'-'.base_convert( md5($content_paragraph[$suchandsuch]), 16, 35);
							$content_paragraph[$suchandsuch] = mariginari_inject_p_id(
								$id, $content_paragraph[$suchandsuch]
							);
						}
						$content_paragraph[$suchandsuch] .= '&nbsp;<a class="mariginari-paragraph-permalink" title="'
							.__('Paragraph permalink', 'mariginari')
							.'" href="'.$post_permalink.'#'.$id.'">#</a>';
					}
				}
			}
			$content = implode('</p>', $content_paragraph);
		}
	}
	return $content;
}
function mariginari_post_pranch($content) {
	global $post;
	return mariginari_pranch($content, 'p'.$post->ID);
}
// run prior to ftc, which runs at p = 12 and modifies the content randomly
// which makes content-based hashes unusable.
add_filter('the_content', 'mariginari_post_pranch', 11);

/*
function mariginari_comment_pranch($content) {
	global $comment;
	return mariginari_pranch($content, 'c'.$comment->comment_ID);
}
add_filter('comment_text', 'mariginari_comment_pranch', 11);
*/


// Generate the style sheet.
function mariginari_get_pranch_style() {
?>
a.mariginari-paragraph-permalink {
	font-size: .75em;
	text-decoration:none;
}
<?php
}
?>
